#======================================
# Script to create data file for country data
#======================================

# to be used for plotting the residuals against the size of the country, see if there is any larger errors
# for larger countries because of bigger distances between the conflict events and cause indicators

# data frame will only be created locally here in the data folder, not included in the master script

setwd("XXX")
rm(list = ls(all = TRUE)) # alles opruimen

#### Load required packages ####
# install.packages("readr")
# library(readr)       # fast csv reader
install.packages("readxl")
library(readxl)      # fast xls(x) reader
install.packages("tidyr")
library(tidyr)       # Data reshaping, needed for function gather 


#### Read data ####
data <- read_excel("COUNTRY_SIZE_ORIG.xls", sheet = "Data", col_names = TRUE, col_types = NULL,skip = 3,na="")

# Fix names - Splits the names and extracts only the numeric year
#colnames(data)[4:ncol(data)] <- colsplit(colnames(data)[4:ncol(data)], split="SOC.", c("TRASH","YEAR"))[,2]

# Gather to country-year units
tdata <- gather(data,YEAR,COUNTRY_SIZE, `1960`:ncol(data))

data2 <- data.frame(row.names = c(1:nrow(tdata))) # maakt een nieuwe lege dataframe
data2$COUNTRY <- tdata$`Country Name`
data2$ISO <- tdata$`Country Code`
data2$YEAR <- as.character(tdata$YEAR)
data2$COUNTRY_SIZE <- tdata$COUNTRY_SIZE

COUNTRY_SIZE <- data2
rm(data,data2,tdata)

#### Bind to id_mat #### (Merging by ISO)

# Merging by ISO, so rename those that don't match
# ik denk niet dat er zijn die niet matchen...

# Merge met data structuur van gcri zodat alleen data die nodig is meegenomen wordt
# mdata <- merge(id_mat, ARABLE_LAND, by.x = c("ISO3C","YEAR"), by.y = c("ISO","YEAR"), all.x=T) # all.x=T zorgt voor een left (outer) join, zodat alleen de jaartallen (en landen?) die in GCRI zitten meegenomen workden

#### Missing values ####
# Impute using previous known values
# mdata <- flp.impute(mdata, 1, 12)

# Rescale from 0 to 10 where a higher FISH score = a lower normalized score
# mdata$ARABLE_LAND <- scale010(mdata$ARABLE_LAND,0) #direction == 0, no direction change

### Final dataset for further use ###

country_size_data <- subset(COUNTRY_SIZE,select = c("COUNTRY_SIZE","YEAR","ISO"))
rm(COUNTRY_SIZE)

save.image("COUNTRY_SIZE.Rdata")